#ifndef GBALIB_HEADER
#define GBALIB_HEADER

void start_interrupts (void);

// initialize all the gbalib variables
void init_gbalib (void);

// Turn bg0 off
void bg0_off (void);

// turn bg0 on
void bg0_on (void);

// wait until vsync starts
#define vsync() while (REG_VCOUNT != 160);

// sets the background palette from u8 rgb pal data
void set_bkg_pal (u8 *data);

// load some tile or sprite data to the given location
void loadchardata(const u8 *chardata, u32 amount, u16 *startram);

// sin of angle x (degrees)
u8 glib_sin (u16 x);

// cos of angle x (degrees)
u8 glib_cos (u16 x);



// sprite functions
// sets the x and y co ordinates of sprite num
void sprite_move (Sprite *s, u16 x, u16 y);

// sets the sprite size
void sprite_size (Sprite *s, u8 size);

// sets the sprite shape
void sprite_shape (Sprite *s, u8 shape);

// sets the sprite image to start at a given tile
void sprite_tile (Sprite *s, u16 tile);


#endif
